##
##  postgresql-datasketches.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2020 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_base 1.1.0
%define       V_snap 20200210

#   package information
Name:         postgresql-datasketches
Summary:      PostgreSQL Extension: Data Sketches Functions
URL:          https://github.com/DataSketches/datasketches-postgres
Vendor:       Oath, Inc.
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Database
License:      Apache
Version:      %{V_base}.%{V_snap}
Release:      20200210

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/postgresql-datasketches/postgresql-datasketches-%{V_snap}.tar.xz
Patch0:       postgresql-datasketches.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101
BuildPreReq:  postgresql
PreReq:       postgresql

%description
    This is an extension module for the PostgreSQL RDBMS to support
    approximate algorithms based on the DataSketches Core library.
    This module currently supports two sketches: CPC (Compressed
    Probabilistic Counting) sketch - very compact (when serialized)
    distinct-counting sketch, and KLL float quantiles sketch - for
    estimating distributions: quantile, rank, PMF (histogram), CDF.

%track
    prog postgresql-datasketches:base = {
        version   = %{V_base}
        url       = https://github.com/DataSketches/datasketches-postgres/releases
        regex     = v(\d+\.\d+\.\d+)\.tar\.gz
    }
    prog postgresql-datasketches:snap = {
        version   = %{V_snap}
        url       = http://download.openpkg.org/components/versioned/postgresql-datasketches/
        regex     = postgresql-datasketches-(\d+)\.tar\.xz
    }

%prep
    %setup -q -n postgresql-datasketches
    %patch -p0

%build
    %{l_make} %{l_mflags} \
        CC="%{l_cc}" \
        CXX="%{l_cxx}" \
        CFLAGS="%{l_cflags -O}" \
        CXXFLAGS="%{l_cxxflags -O}" \
        CPPFLAGS="%{l_cppflags}" \
        LDFLAGS="%{l_cppflags}" \
        datasketches.so

%install
    %{l_make} %{l_mflags} \
        DESTDIR=$RPM_BUILD_ROOT \
        CC="%{l_cc}" \
        CXX="%{l_cxx}" \
        CFLAGS="%{l_cflags -O}" \
        CXXFLAGS="%{l_cxxflags -O}" \
        CPPFLAGS="%{l_cppflags}" \
        LDFLAGS="%{l_cppflags}" \
        install
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

